#!/usr/bin/wish
# Canvas chapter

proc PolyInit {} {
     canvas .c -width 800 -height 800 -bg cyan; pack .c
     # rotation around center cx,cy
     # size of the object dx dy
     global K
     global abs_ang
     set abs_ang 0.0
     global cx cy
     global C_pi

     .c create rect 100 100 500 500 

       set K(1,x1) 100; set K(1,y1) 100 
       set K(1,x2) 500; set K(1,y2) 100
       set K(1,x3) 300; set K(1,y3) 300
       set K(1,x4) 100; set K(1,y4) 100
       set K(1,xc) 300; set K(1,yc) 200

       set K(2,x1) 100; set K(2,y1) 100
       set K(2,x2) 300; set K(2,y2) 300
       set K(2,x3) 100; set K(2,y3) 500
       set K(2,x4) 100; set K(2,y4) 100
       set K(2,xc) 200; set K(2,yc) 300

       set K(3,x1) 100; set K(3,y1) 500; set K(3,x2) 300; set K(3,y2) 500
       set K(3,x3) 200; set K(3,y3) 400; set K(3,x4) 100; set K(3,y4) 500
       set K(3,xc) 200; set K(3,yc) 450

       set K(4,x1) 200; set K(4,y1) 400; set K(4,x2) 300; set K(4,y2) 300
       set K(4,x3) 400; set K(4,y3) 400; set K(4,x4) 300; set K(4,y4) 500
       set K(4,xc) 350; set K(4,yc) 350

       set K(5,x1) 300; set K(5,y1) 300; set K(5,x2) 400; set K(5,y2) 400
       set K(5,x3) 400; set K(5,y3) 200; set K(5,x4) 300; set K(5,y4) 300
       set K(5,xc) 300; set K(5,yc) 350

       set K(6,x1) 500; set K(6,y1) 100; set K(6,x2) 500; set K(6,y2) 300
       set K(6,x3) 400; set K(6,y3) 400; set K(6,x4) 400; set K(6,y4) 200
       set K(6,xc) 450; set K(6,yc) 250

       set K(7,x1) 500; set K(7,y1) 300; set K(7,x2) 500; set K(7,y2) 500
       set K(7,x3) 300; set K(7,y3) 500; set K(7,x4) 500; set K(7,y4) 300
       set K(7,xc) 450; set K(7,yc) 450

      .c create poly $K(1,x1) $K(1,y1) $K(1,x2) $K(1,y2) $K(1,x3) $K(1,y3) \
                     $K(1,x4) $K(1,y4) -tag {1 pp} -fill blue -outline white
      .c create poly $K(2,x1) $K(2,y1) $K(2,x2) $K(2,y2) $K(2,x3) $K(2,y3) \
                     $K(2,x4) $K(2,y4) -tag {2 pp} -fill blue -outline white
      .c create poly $K(3,x1) $K(3,y1) $K(3,x2) $K(3,y2) $K(3,x3) $K(3,y3) \
                     $K(3,x4) $K(3,y4) -tag {3 pp} -fill blue -outline white
      .c create poly $K(4,x1) $K(4,y1) $K(4,x2) $K(4,y2) $K(4,x3) $K(4,y3) \
                     $K(4,x4) $K(4,y4) -tag {4 pp} -fill blue -outline white
      .c create poly $K(5,x1) $K(5,y1) $K(5,x2) $K(5,y2) $K(5,x3) $K(5,y3) \
                     $K(5,x4) $K(5,y4) -tag {5 pp} -fill blue -outline white
      .c create poly $K(6,x1) $K(6,y1) $K(6,x2) $K(6,y2) $K(6,x3) $K(6,y3) \
                     $K(6,x4) $K(6,y4) -tag {6 pp} -fill blue -outline white
      .c create poly $K(7,x1) $K(7,y1) $K(7,x2) $K(7,y2) $K(7,x3) $K(7,y3) \
                     $K(7,x4) $K(7,y4) -tag {7 pp} -fill blue -outline white

      # bindings 
     .c bind pp <Button-1> {ObjMark %W %x %y}
     .c bind pp <Shift-Button-3> {PolyRot %W %x %y 1}
     .c bind pp <Button-3> {PolyRot %W %x %y -1}
     .c bind pp <B1-Motion> {ObjShift %W %x %y}
     
     }

proc ObjMark { w x y } {
     global myob
     set myob($w,obj) [$w find closest $x $y]
     set myob($w,x) $x
     set myob($w,y) $y
     puts stdout "[lindex [$w gettags [$w find closest $x $y] ] 0]"
     }

proc PolyRot { w x y dir} {
     global myob abs_ang
     global cx cy
     global K
     # del_ang is incremental rotation del_angle of the object 
     # default + or - 5 degr 
     set del_ang [expr $dir*15*0.0174532]
     # abs_ang is the current rot-angle with respect to thre 
     # initial object
     set abs_ang [expr $abs_ang + $del_ang]
     set myob($w,obj) [$w find closest $x $y]
     puts $myob($w,obj)
     set i [lindex [$w gettags [$w find closest $x $y] ] 0]
     # new coordinates
     # we rotate the 4 coord-pairs p1 po2 p3 p4 around the axis 
     # located in the center of the figure = cx, cy
     # the angle step is del_angle
     # the new total angle = abs_ang
     for {set j 1} {$j < 5} { incr j 1} {
     set d1 [expr $K($i,xc)+($K($i,x$j)-$K($i,xc))*cos($del_ang) - \
                            ($K($i,y$j)-$K($i,yc))*sin($del_ang) ]
     set d2 [expr $K($i,yc)+($K($i,x$j)-$K($i,xc))*sin($del_ang) + \
                            ($K($i,y$j)-$K($i,yc))*cos($del_ang) ]
     set K($i,x$j) $d1; set K($i,y$j)  $d2
     }



     # delete the object
	  catch {$w delete $myob($w,obj) }
     # create it anew
  .c create poly $K($i,x1) $K($i,y1) $K($i,x2) $K($i,y2) $K($i,x3) $K($i,y3) \
                 $K($i,x4) $K($i,y4) -tag "$i pp" -fill blue -outline white

     #catch {$w delete $myob($w,obj)}
     #set box(last) [eval {$w create rect} $box(anchor) \
     #   { $x $y -tag box}]
     }

proc ObjShift { w x y} {
     global myob cx cy dx dy
     global K
     set shift_x [expr $x - $myob($w,x)]
     set shift_y [expr $y - $myob($w,y)]
     $w move $myob($w,obj) $shift_x $shift_y
     set myob($w,x) $x
     set myob($w,y) $y 
     set i [lindex [$w gettags [$w find closest $x $y] ] 0]
     # set cx [expr $cx+$shift_x]
     # set cy [expr $cy+$shift_y]
     foreach j { 1 2 3 4 c } {
     set K($i,x$j) [expr $K($i,x$j)+$shift_x]; 
     set K($i,y$j) [expr $K($i,y$j)+$shift_y]
     }

     }
   
set C_pi 3.141539
set r 10
PolyInit
